/******************************************************************************
*                                                                             *
*    ClientAdviseSink.h                     Copyright(c) 2007-2010 itow,y.    *
*                                                                             *
******************************************************************************/

/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef ANT_CLIENTADVISESINK_H
#define ANT_CLIENTADVISESINK_H


#include "TACManager.h"


struct IUnknown;
class IRMAClientAdviseSink;
class IRMAPNRegistry;


class AntClientAdviseSink : public IRMAClientAdviseSink
{
	LONG m_lRefCount;
	IUnknown *m_pUnknown;
	IRMAPNRegistry *m_pRegistry;
	AntTACManager *m_pTACManager;
	~AntClientAdviseSink();
	void ShowMeTheStatistics(const char *pszRegistryKey);

public:
	AntClientAdviseSink(IUnknown *pUnknown);
	AntTACManager *GetTACManager() { return m_pTACManager; }
// IUnknown
	STDMETHOD(QueryInterface)(REFIID riid,void **ppObj);
	STDMETHOD_(ULONG,AddRef)();
	STDMETHOD_(ULONG,Release)();
// IRMAClientAdviseSink
	STDMETHOD(OnPosLength)(UINT32 ulPosition,UINT32 ulLength);
	STDMETHOD(OnPresentationOpened)();
	STDMETHOD(OnPresentationClosed)();
	STDMETHOD(OnStatisticsChanged)();
	STDMETHOD(OnPreSeek)(UINT32 ulOldTime,UINT32 ulNewTime);
	STDMETHOD(OnPostSeek)(UINT32 ulOldTime,UINT32 ulNewTime);
	STDMETHOD(OnStop)();
	STDMETHOD(OnPause)(UINT32 ulTime);
	STDMETHOD(OnBegin)(UINT32 ulTime);
	STDMETHOD(OnBuffering) (UINT32 ulFlags,UINT16 unPercentComplete);
	STDMETHOD(OnContacting)(const char *pHostName);
};


#endif	// ndef ANT_CLIENTADVISESINK_H
