/******************************************************************************
*                                                                             *
*    ClientContext.h                        Copyright(c) 2007-2010 itow,y.    *
*                                                                             *
******************************************************************************/

/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef ANT_CLIENTCONTEXT_H
#define ANT_CLIENTCONTEXT_H


class AntClientAdviseSink;
class AntErrorSink;
class AntAuthenticationManager;
class AntSiteSupplier;

class AntClientContext : public IUnknown
{
	LONG m_RefCount;
	AntClientAdviseSink *m_pClientSink;
	AntErrorSink *m_pErrorSink;
	AntAuthenticationManager *m_pAuthMgr;
	AntSiteSupplier *m_pSiteSupplier;

public:
	AntClientContext();
	~AntClientContext();
// IUnknown
	STDMETHOD(QueryInterface)(REFIID riid,void **ppObj);
	STDMETHOD_(ULONG,AddRef)();
	STDMETHOD_(ULONG,Release)();
// AntClientContext
	void Init(IUnknown *pUnknown);
	void Close();
	HWND GetWindow();
	AntClientAdviseSink *GetClientAdviseSink() { return m_pClientSink; }
};


#endif	// ndef ANT_CLIENTCONTEXT_H
