/******************************************************************************
*                                                                             *
*    ErrorSink.h                            Copyright(c) 2007-2010 itow,y.    *
*                                                                             *
******************************************************************************/

/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef ANT_ERRORSINK_H
#define ANT_ERRORSINK_H


class IUnknown;
class IRMAErrorMessages;
class IRMABuffer;

class AntErrorSink : public IRMAErrorSink
{
protected:
	LONG m_lRefCount;
	IUnknown *m_pUnknown;
	~AntErrorSink();
	IRMABuffer *GetErrorText(const ULONG32 RMACode);
	static INT_PTR CALLBACK ErrorDlgProc(HWND hDlg,UINT uMsg,
												WPARAM wParam,LPARAM lParam);

public:
	AntErrorSink(IUnknown *pUnknown);
// IUnknown
	STDMETHOD(QueryInterface)(REFIID iid,void **ppObj);
	STDMETHOD_(ULONG,AddRef)();
	STDMETHOD_(ULONG,Release)();
// IRMAErrorSink
	STDMETHOD(ErrorOccurred)(const UINT8 Severity,const UINT32 RMACode,
								const UINT32 UserCode,const char *pUserString,
													const char *pMoreInfoURL);
};


#endif	// ANT_ERRORSINK_H
