/******************************************************************************
*                                                                             *
*    SiteSupplier.h                         Copyright(c) 2007-2010 itow,y.    *
*                                                                             *
******************************************************************************/

/*
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#ifndef ANT_SITESUPPLIER_H
#define ANT_SITESUPPLIER_H


#include "Map.h"


class AntSiteSupplier : public IRMASiteSupplier, public IRMASiteWatcher
{
	LONG m_RefCount;
	IRMASiteManager *m_pSiteManager;
	IRMACommonClassFactory *m_pCCF;
	IUnknown *m_pUnkPlayer;
	AntMap m_CreatedSites;
	HWND m_hwnd;
	~AntSiteSupplier();

public:
	AntSiteSupplier(IUnknown* pUnkPlayer);
	HWND GetWindow() { return m_hwnd; }
// IUnknown
	STDMETHOD(QueryInterface)(REFIID riid,void **ppObj);
	STDMETHOD_(ULONG,AddRef)();
	STDMETHOD_(ULONG,Release)();
// IRMASiteSupplier
	STDMETHOD(SitesNeeded)(UINT32 RequestID, IRMAValues *pSiteProps);
	STDMETHOD(SitesNotNeeded)(UINT32 RequestID);
	STDMETHOD(BeginChangeLayout)();
	STDMETHOD(DoneChangeLayout)();
// IRMASiteWatcher
	STDMETHOD(AttachSite)(IRMASite *pSite);
	STDMETHOD(DetachSite)();
	STDMETHOD(ChangingPosition)(PNxPoint posOld,REF(PNxPoint) posNew);
	STDMETHOD(ChangingSize)(PNxSize sizeOld,REF(PNxSize) sizeNew);
};


#endif	// ndef ANT_SITESUPPLIER_H
